// 
// Author:
//       smdn <smdn@mail.invisiblefulmoon.net>
// 
// Copyright (c) 2009 smdn
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

using System;
using System.Net;

namespace Smdn.Protocols.Imap4.Client.Protocol.Authentication {
  internal abstract class AuthenticationModuleBase : IImapAuthenticationModule {
    public abstract ImapAuthenticationMechanism Mechanism { get; }

    protected int AuthenticationStep { get; set; }

    protected AuthenticationModuleBase()
    {
      AuthenticationStep = 0;
    }

    public abstract string ExchangeChallengeResponse(ImapCommandContinuationRequest challenge, ImapConnection connection, NetworkCredential credential);

    protected static string ToLowerCaseHexString(byte[] bytes)
    {
      var chars = new char[bytes.Length * 2];
      var b = 0;
      var c = 0;

      for (; b < bytes.Length;) {
        chars[c++] = lowerCaseHexChars[bytes[b] >> 4];
        chars[c++] = lowerCaseHexChars[bytes[b] & 0xf];
        b++;
      }

      return new string(chars);
    }

    private static readonly char[] lowerCaseHexChars = new char[] {
      '0', '1', '2', '3',
      '4', '5', '6', '7',
      '8', '9', 'a', 'b',
      'c', 'd', 'e', 'f'
    };
  }
}